/* Commande d'un aérateur mécanisé par un servo moteur avec ventilation 
 *  forcée, par une sonde DHT11 et Arduino Nanao ... Visualisation sur  
 *  afficheur Oled I2C de la valeur consigne, de la température et de l'umidité 
 */
//#include <SPI.h>
#include <Wire.h> // Utilisation de la Library Communication 1 fil
#include <Adafruit_SSD1306.h> // Utilisation de la Library Gestion Afficheur

#define OLED_RESET 4 // Utilisation de la Library Start Afficheur
Adafruit_SSD1306 display(OLED_RESET);  //définition de la séquence d'affichage

#include <dht.h> // Utilisation de la Library Gestion de la sonde
dht DHT;
#define DHT11_PIN 11 //Sonde connectée à la D11 du nano

#include <Servo.h>  // Utilisation de la Library Gestion de Servomoteur
Servo myservo;  // Creation d'un nom de definition pour ce servo

int Vent = 4;  //Déclaration de la commande de ventilateur en D4
int Val = 0; //Déclaration de la valeur lue sur le potentiometre
int Cons = 0; //Déclaration de la valeur potentiomètre tranlatée en valeur consigne 

int pos = 0;    //Variable de position de servo "Fermé"
int pos1 = 120;  //Variable de position de servo "Ouvert"

void setup() {
  pinMode(Vent, OUTPUT); //Mise en sortie de la commande de ventillateur
  myservo.attach(3); //Déclaration de la commande de servo en D3
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);  // Initialisation de l'afficheur et son adresse I2C 
  Wire.begin();  // Initialisation de la communication 1 fil
//  dht.begin(); // initialize dht
//    int chk = DHT.read11(DHT11_PIN);
  delay(1000);
ecran();  // Première écriture sur écran

}


void loop(){
Cons = analogRead(Val); //Lecture de la valeur consigne sur le potar Val

DHT.read11(DHT11_PIN); //Lecture des valeurs Humidité et température sur la sonde

if ((DHT.temperature)< ((Cons/25)-10)) { //Si la température est plus basse que celle consignée
    digitalWrite(Vent, LOW);  // on arrête le ventilateur
      myservo.write(pos);  // et on ferme l'aérateur
      ecran();  // et on affiche les valeurs
}

if ((DHT.temperature)> ((Cons/25)-10)) { //Si la température est plus Haute que celle consignée
      myservo.write(pos1);  // on ouvre l'aérateur
      ecran();  // et on affiche les valeurs
}

if (((DHT.humidity)> 60) and ((DHT.temperature)> ((Cons/25)-10))) { //Si l'humidité est supérieur à 50% et la température est plus Haute que celle consignée
    digitalWrite(Vent, HIGH);  // on active le ventilateur
      myservo.write(pos1);  // on ouvre l'aérateur
      ecran();  // et on affiche les valeurs
}
   delay (2000); // un peu d'attente avant la prochaine lecture...
}

void ecran() {
display.display();  // initialisation d'une séquence d'affichage 
display.clearDisplay(); // Effacement des écrits précédents  
display.setTextSize(1);  // Choix de la taille des caractères 
display.setTextColor(WHITE); // Choix de la couleur des caractères 
display.setCursor(1,0); // Position curseur 
display.println("Consigne: ");
display.setCursor(70,0);  // Position curseur
display.println((Cons/25)-10);
display.setCursor(90,0);  // Position curseur
display.println(" degC");
display.setCursor(1,11);  // Position curseur
display.println("Temperature:");
display.setCursor(70,11);  // Position curseur
display.println(DHT.temperature);
display.setCursor(90,11);  // Position curseur
display.println(" degC");
display.setCursor(1,21);  // Position curseur
display.println("Humidite: ");
display.setCursor(70,21);  // Position curseur
display.println(DHT.humidity);
display.setCursor(90,21);  // Position curseur
display.println(" %");

     
              
}
