
/* Commande d'un aérateur mécanisé par un servo moteur avec ventilation 
 *  forcée, par une sonde SHT31 et Arduino Nanao ... Visualisation sur  
 *  afficheur Oled I2C de la valeur consigne, de la température et de l'umidité 
 */
#include <Adafruit_SSD1306.h> // Utilisation de la Library Gestion Afficheur
#define OLED_RESET 4 // Utilisation de la Library Start Afficheur
Adafruit_SSD1306 display(OLED_RESET);  //définition de la séquence d'affichage

#include "Adafruit_SHT31.h"  // Utilisation de la Library Gestion de la sonde
Adafruit_SHT31 sht31 = Adafruit_SHT31(); //définition de la séquence de sonde

#include <Servo.h>  // Utilisation de la Library Gestion de Servomoteur
Servo myservo;  // Creation d'un nom de definition pour ce servo

int Vent = 4;  //Déclaration de la commande de ventilateur en D4
int Val = 0; //Déclaration de la valeur lue sur le potentiometre
int Cons = 0; //Déclaration de la valeur potentiomètre tranlatée en valeur consigne 

int pos = 0;    //Variable de position de servo "Fermé"
int pos1 = 90;  //Variable de position de servo "Ouvert"

void setup()
{
if (! sht31.begin(0x44)) // Controle de la présence de la sonde à le bonne adresse
  {
    while (1) delay(1);  // Et, si oui, on boucle tant qu'elle est vue 
}

pinMode(Vent, OUTPUT); //Mise en sortie de la commande de ventillateur
myservo.attach(3); //Déclaration de la commande de servo en D3
display.begin(SSD1306_SWITCHCAPVCC, 0x3C);  // Initialisation de l'afficheur et son adresse I2C 
}


void loop()
{
Cons = analogRead(Val); //Lecture de la valeur consigne sur le potar Val
  
float t = sht31.readTemperature(); //lance la séquence de lecture de la température
float h = sht31.readHumidity(); //Idem pour l'humidité ambiante 

display.display();  // initialisation d'une séquence d'affichage 
display.clearDisplay(); // Effacement des écrits précédents 
display.setTextSize(1);  // Choix de la taille des caractères 
display.setTextColor(WHITE); // Choix de la couleur des caractères 
display.setCursor(1,0); // Position curseur 
display.println("Consigne: ");
display.setCursor(70,0);  // Position curseur
display.println((Cons/25)-10);
display.setCursor(90,0);  // Position curseur
display.println(" degC");
display.setCursor(1,11);  // Position curseur
display.println("Temperature:");
display.setCursor(70,11);  // Position curseur
display.println(t,1);
display.setCursor(90,11);  // Position curseur
display.println(" degC");
display.setCursor(1,21);  // Position curseur
display.println("Humidite: ");
display.setCursor(70,21);  // Position curseur
display.println(h,1);
display.setCursor(90,21);  // Position curseur
display.println(" %");


if ((t)< ((Cons/25)-10)) { //Si la température est plus basse que celle consignée
    digitalWrite(Vent, LOW);  // on arrête le ventilateur
      myservo.write(pos);  // et on ferme l'aérateur
}

if ((t)> ((Cons/25)-10)) { //Si la température est plus Haute que celle consignée
      myservo.write(pos1);  // on ouvre l'aérateur
}

if ((((h)> 60)) and ((t)> ((Cons/25)-10))) { //Si l'humidité est supérieur à 50% et la température est plus Haute que celle consignée
    digitalWrite(Vent, HIGH);  // on active le ventilateur
      myservo.write(pos1);  // on ouvre l'aérateur
}else{
    digitalWrite(Vent, LOW);  // on désactive le ventilateur
}
delay(5000); //Temporisation de 5secondes avant nouvelle lercture  
}
